-- call with ghci -fglasgow-exts -iStrategyLib-5.0/models/deriving -iStrategyLib-5.0/library -fallow-undecidable-instances -fno-monomorphism-restriction DNFRecognizer.hs

module DNFRecognizer where

import Maybe
import Debug.Trace

import Data.Generics

import ApplyStrategy
import ParserCombinatorsWithStateBFLib

import Logic

tNotNot = parse (pSym NotNot) [NotNot] (At (Not (Not (LVar "yes"))) Top)

pEliminateNots :: forall b domain.
                  (Apply TLogic (Loc domain b), Data domain, Children domain,Show domain, Show b) =>
                  Parser TLogic (Loc domain b) (Loc domain b) TLogic
pEliminateNots = let strategy = Basic (Eval deMorganOr) `Or` Basic (Eval deMorganAnd) `Or` Basic (Eval notNot)
                 in pRepeatExhausted (pSym DeMorganAnd <|> pSym DeMorganOr <|> pSym NotNot) strategy

tEliminateNots1 = parse pEliminateNots [NotNot] (At (Not (Not (Not (Not (LVar "yes"))))) Top)
tEliminateNots2 = parse pEliminateNots [NotNot,NotNot] (At (Not (Not (Not (Not (LVar "yes"))))) Top)
tEliminateNots3 = parse pEliminateNots [NotNot,NotNot,NotNot] (At (Not (Not (Not (Not (LVar "yes"))))) Top)
tEliminateNots4 = parse pEliminateNots [NotNot,TLogicQED] (At (Not (Not (LVar "yes"))) Top)
tEliminateNots5 = parse pEliminateNots [NotNot,NotNot,TLogicQED] (At (Not (Not (LVar "yes"))) Top)
tEliminateNots6 = undefined

pMoveOrToTop = let strategy = Basic (Eval andOverOr)
               in pRepeatExhausted (pSym AndOverOr) strategy

tMoveOrToTop1 = parse pMoveOrToTop [AndOverOr] (At (LVar "1" :&&: (LVar "2" :||: LVar "3")) Top)
tMoveOrToTop2 = parse pMoveOrToTop [AndOverOr,TLogicQED] (At (LVar "1" :&&: (LVar "2" :||: LVar "3")) Top)

pDNF =    pUpdateLoc ("Entering pEliminateNots":) *>
       pEliminateNots <*
          pUpdateLoc tail
       *> 
          pUpdateLoc ("Entering pMoveOrToTop":) *>
       pMoveOrToTop <*
          pUpdateLoc tail

tDNF1 = parse pDNF [DeMorganOr,LMove DAndR,DeMorganAnd,LMove DUp,AndOverOr,TLogicQED] 
                   (At (Not (LVar "1" :||: (LVar "2" :&&: LVar "3"))) Top)
tDNF2 = parse pDNF [DeMorganOr,LMove DAndR,DeMorganAnd,LMove DUp,TLogicQED] 
                   (At (Not (LVar "1" :||: (LVar "2" :&&: LVar "3"))) Top)
tDNF3 = parse pDNF [DeMorganOr,LMove DAndR,DeMorganOr,LMove DUp,AndOverOr,TLogicQED] 
                   (At (Not (LVar "1" :||: (LVar "2" :&&: LVar "3"))) Top)

tnA = notApplicableAnyWhere (Basic (Eval deMorganOr) `Or` Basic (Eval deMorganAnd) `Or` Basic (Eval notNot)) 
                            (Not (LVar "1") :&&: (Not (LVar "2") :||: Not (LVar "3")))
